
#include <windows.h>  
#include <commctrl.h>
#include "finditem.h"  


#if defined (WIN32)
	#define IS_WIN32 TRUE
#else
	#define IS_WIN32 FALSE
#endif

#define IS_NT      IS_WIN32 && (BOOL)(GetVersion() < 0x80000000)
#define IS_WIN32S  IS_WIN32 && (BOOL)(!(IS_NT) && (LOBYTE(LOWORD(GetVersion()))<4))
#define IS_WIN95   (BOOL)(!(IS_NT) && !(IS_WIN32S)) && IS_WIN32

HINSTANCE hInst;   // current instance

LPCTSTR lpszAppName = "App";
LPCTSTR lpszTitle   = "ListView_FindItem()"; 


BOOL RegisterWin95( CONST WNDCLASS* lpwc );


int APIENTRY WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
                      LPTSTR lpCmdLine, int nCmdShow)
{
   MSG      msg;
   HWND     hWnd; 
   WNDCLASS wc;

   wc.style         = CS_HREDRAW | CS_VREDRAW;
   wc.lpfnWndProc   = (WNDPROC)WndProc;       
   wc.cbClsExtra    = 0;                      
   wc.cbWndExtra    = 0;                      
   wc.hInstance     = hInstance;              
   wc.hIcon         = LoadIcon (hInstance, lpszAppName); 
   wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
   wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
   wc.lpszMenuName  = lpszAppName;              
   wc.lpszClassName = lpszAppName;              

   if ( IS_WIN95 )
   {
      if ( !RegisterWin95( &wc ) )
         return( FALSE );
   }
   else if ( !RegisterClass( &wc ) )
      return( FALSE );

   hInst = hInstance; 

   hWnd = CreateWindow( lpszAppName, 
                        lpszTitle,    
                        WS_OVERLAPPEDWINDOW, 
                        CW_USEDEFAULT, 0, 
                        CW_USEDEFAULT, 0,  
                        NULL,              
                        NULL,              
                        hInstance,         
                        NULL               
                      );

   if ( !hWnd ) 
      return( FALSE );

   ShowWindow( hWnd, nCmdShow ); 
   UpdateWindow( hWnd );         

   while( GetMessage( &msg, NULL, 0, 0) )   
   {
      TranslateMessage( &msg ); 
      DispatchMessage( &msg );  
   }

   return( msg.wParam ); 
}


BOOL RegisterWin95( CONST WNDCLASS* lpwc )
{
   WNDCLASSEX wcex;

   wcex.style         = lpwc->style;
   wcex.lpfnWndProc   = lpwc->lpfnWndProc;
   wcex.cbClsExtra    = lpwc->cbClsExtra;
   wcex.cbWndExtra    = lpwc->cbWndExtra;
   wcex.hInstance     = lpwc->hInstance;
   wcex.hIcon         = lpwc->hIcon;
   wcex.hCursor       = lpwc->hCursor;
   wcex.hbrBackground = lpwc->hbrBackground;
   wcex.lpszMenuName  = lpwc->lpszMenuName;
   wcex.lpszClassName = lpwc->lpszClassName;

   // Added elements for Windows 95.
   //...............................
   wcex.cbSize = sizeof(WNDCLASSEX);
   wcex.hIconSm = LoadImage(wcex.hInstance, lpwc->lpszClassName, 
                            IMAGE_ICON, 16, 16,
                            LR_DEFAULTCOLOR );
			
   return RegisterClassEx( &wcex );
}


LPCTSTR lpszData[4]  = { "Circle", "Rectangle", "Cross", "Check" };
LPCTSTR lpszColor[4] = { "Yellow", "Red",       "Black", "Black" };

LRESULT CALLBACK WndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
static char  szBuf[40];
static UINT  uTimerID = 0;
static HWND  hList    = NULL;
static HWND  hStatic  = NULL;

   switch( uMsg )
   {
      case WM_CREATE  :
              {
                 HIMAGELIST hImage, hSmall;

                 InitCommonControls();

                 // Create the image lists and the list view.
                 //..........................................
                 hImage = ImageList_Create( 32, 32, ILC_COLOR4 | ILC_MASK, 4, 1 ); 
                 hSmall = ImageList_Create( 16, 16, ILC_COLOR4 | ILC_MASK, 4, 1 );
                 hList  = CreateWindowEx( 0, WC_LISTVIEW, "",
                                          WS_CHILD | WS_VISIBLE | LVS_REPORT | 
                                          LVS_EDITLABELS | LVS_SINGLESEL,
                                          0, 20, 100, 100,
                                          hWnd,
                                          (HMENU)1,
                                          hInst,
                                          NULL);

                 hStatic = CreateWindowEx( 0, "STATIC", "", WS_CHILD | WS_VISIBLE,
                                           0, 0, 100, 20,
                                           hWnd,
                                           (HMENU)2,
                                           hInst,
                                           NULL );

                 if ( hList && hImage && hSmall )
                 {
                    LV_COLUMN col;
                    LV_ITEM   item;
                    int       i;

                    // Set the large and small image lists.
                    //.....................................
                    ListView_SetImageList( hList, hImage, LVSIL_NORMAL );
                    ListView_SetImageList( hList, hSmall, LVSIL_SMALL );

                    // Add the images to the image list.
                    //..................................
                    for( i=0; i<4; i++ )
                    {
                       ImageList_AddIcon( hImage, LoadIcon( hInst, lpszData[i] ) );
                       ImageList_AddIcon( hSmall, LoadIcon( hInst, lpszData[i] ) );
                    }

                    // Add the columns for the report view.
                    //.....................................
                    col.mask    = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM; 
                    col.fmt     = LVCFMT_LEFT; 
                    col.cx      = 100; 

                    col.pszText  = "Name"; 
                    col.iSubItem = 0;
                    ListView_InsertColumn( hList, 0, &col );
                    
                    col.pszText  = "Color"; 
                    col.iSubItem = 1;
                    ListView_InsertColumn( hList, 1, &col );

                    // Insert items into the list view.
                    //.................................
                    for( i=0; i<4; i++ )
                    {
                       item.mask     = LVIF_TEXT | LVIF_IMAGE;
                       item.pszText  = (LPTSTR)lpszData[i];
                       item.iItem    = i;
                       item.iSubItem = 0;
                       item.iImage   = i;
                       ListView_InsertItem( hList, &item );

                       item.mask     = LVIF_TEXT;
                       item.pszText  = (LPTSTR)lpszColor[i];
                       item.iSubItem = 1;
                       ListView_SetItem( hList, &item );
                    }
                 }

                 uTimerID = SetTimer( hWnd, 1, 500, NULL );
              }
              break;

      case WM_SIZE :
              if ( hStatic )
                 MoveWindow( hStatic, 0, 0, LOWORD( lParam ), 20, FALSE );

              if ( hList )
                 MoveWindow( hList, 0, 20, LOWORD( lParam ), HIWORD( lParam )-20, FALSE );

              if ( wParam == SIZE_RESTORED || wParam == SIZE_MAXIMIZED )
                 ListView_RedrawItems( hList, 0, ListView_GetItemCount( hList ) );
              break;


      case WM_TIMER :
              if ( wParam == uTimerID )
              {
                 ListView_GetISearchString( hList, szBuf );
                 SetWindowText( hStatic, szBuf );
              }
              break;

      case WM_COMMAND :
              switch( LOWORD( wParam ) )
              {
                 case IDM_FIND :
                        {
                           LV_FINDINFO fi;
                           int         nItem = -1;       

                           fi.flags = LVFI_STRING;
                           fi.psz   = "Rectangle";

                           nItem = ListView_FindItem( hList, -1, &fi );

                           if ( nItem > -1 &&
                                !(ListView_GetItemState( hList, nItem,
                                             LVIS_SELECTED) & LVIS_SELECTED) )
                           {
                              ListView_EnsureVisible( hList, nItem, FALSE );
                              ListView_SetItemState( hList, nItem, 
                                                     LVIS_SELECTED | LVIS_FOCUSED, 
                                                     LVIS_SELECTED | LVIS_FOCUSED); 
                           }
                        }
                        break;      

                 case IDM_ABOUT :
                        DialogBox( hInst, "AboutBox", hWnd, (DLGPROC)About );
                        break;

                 case IDM_EXIT :
                        DestroyWindow( hWnd );
                        break;
              }
              break;
      
      case WM_DESTROY :
              KillTimer( hWnd, uTimerID );

              if ( ListView_GetImageList( hList, LVSIL_NORMAL ) )
                 ImageList_Destroy( ListView_GetImageList( hList, LVSIL_NORMAL ) );

              if ( ListView_GetImageList( hList, LVSIL_SMALL ) )
                 ImageList_Destroy( ListView_GetImageList( hList, LVSIL_SMALL ) );

              PostQuitMessage(0);
              break;

      default :
            return( DefWindowProc( hWnd, uMsg, wParam, lParam ) );
   }

   return( 0L );
}


LRESULT CALLBACK About( HWND hDlg,           
                        UINT message,        
                        WPARAM wParam,       
                        LPARAM lParam)
{
   switch (message) 
   {
       case WM_INITDIALOG: 
               return (TRUE);

       case WM_COMMAND:                              
               if (   LOWORD(wParam) == IDOK         
                   || LOWORD(wParam) == IDCANCEL)    
               {
                       EndDialog(hDlg, TRUE);        
                       return (TRUE);
               }
               break;
   }

   return (FALSE); 
}
